'******************************************************************************
'*  trs80.spin - Demo mode for the TRS80 video and render cogs
'*
'*  (c) Juergen Buchmueller <pullmoll@t-online.de>
'*
'* $Id$
'******************************************************************************
CON
	_xinfreq		= 5_000_000		' Quartz is 5MHz
	_clkmode		= xtal1 + pll16x	' System clock is 80MHz

#define PAL

OBJ
        render	: "trs80_render"
	video	: "trs80_video"
	fdx	: "FullDuplexSerial_rr004"
VAR
	long	params[4]

	long	curx
	long	cury

PUB     main : okay | i, j, w

	params[0] := @sync_
	params[1] := @videoram_
	params[2] := @bitmaps_
	params[3] := 14

	fdx.start(31,30,0,115200)
	longfill(params[1], $20202020, 64*16/4)
	video.start(@params)
        render.start(@params)
	repeat while 1
		str(string("The quick brown fox jumps over the lazy dog.  "))
		str(string("Hello world!  "))
		chr($81)
		chr($84)
		chr($93)
		chr($a0)
		chr(32)
		chr(32)
		waitcnt(cnt + 10_000_000)
        okay := 0

PUB chr(ch)
	if ch == 13
		curx := 64
	else
		videoram_[cury*64+curx] := ch
		curx++
	if curx == 64
		curx := 0
		cury++
		if cury == 16
			longmove(params[1], params[1] + 64, 64*15/4)
			longfill(params[1] + 64*15, $20202020, 64/4)
			cury := 15

PUB str(stringptr)
'' Print a zero-terminated string
	repeat strsize(stringptr)
		chr(byte[stringptr++])

PUB hex(value, digits)
'' Print a hexadecimal number to the PST
	value <<= (8 - digits) << 2
	repeat digits
		fdx.tx(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))

DAT
sync_		long    0
bitmaps_	long	0[2*64*6/8/4]
videoram_	byte	0[64*16]
