'******************************************************************************
'*  trs80_render.spin - Render a TRS80 video RAM into 2 scanline bitmap buffers
'*
'*  (c) Juergen Buchmueller <pullmoll@t-online.de>
'*
'* $Id: yaz80_demo.spin,v 1.8 2010-03-21 12:43:11 pm Exp $
'******************************************************************************

VAR
	long	cog

PUB start(params) : okay
	stop

	okay := cog := COGNEW(@entry, params) + 1

PUB stop
	if cog
		COGSTOP(cog - 1)
		cog := 0

DAT
entry
		jmp	#startup

				' chr($00)
'		byte	$00	' ........
'		byte	$3e	' .#####..
'		byte	$22	' .#...#..
'		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..

				' chr($01)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......

				' chr($02)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$3e	' .#####..

				' chr($03)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$3e	' .#####..

				' chr($04)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$3c	' ..####..
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$20	' .....#..

				' chr($05)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$36	' .##.##..
		byte	$2a	' .#.#.#..
		byte	$36	' .##.##..
		byte	$22	' .#...#..
		byte	$3e	' .#####..

				' chr($06)
		byte	$00	' ........
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$0a	' .#.#....
		byte	$06	' .##.....
		byte	$02	' .#......
		byte	$00	' ........

				' chr($07)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$36	' .##.##..

				' chr($08)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$1e	' .####...
		byte	$24	' ..#..#..
		byte	$28	' ...#.#..
		byte	$20	' .....#..
		byte	$20	' .....#..

				' chr($09)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$3e	' .#####..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$00	' ........

				' chr($0a)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..

				' chr($0b)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$00	' ........

				' chr($0c)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$08	' ...#....

				' chr($0d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$3e	' .#####..
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$00	' ........

				' chr($0e)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$36	' .##.##..
		byte	$2a	' .#.#.#..
		byte	$36	' .##.##..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($0f)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2a	' .#.#.#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($10)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..

				' chr($11)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$3a	' .#.###..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($12)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3a	' .#.###..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...

				' chr($13)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2e	' .###.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...

				' chr($14)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$2e	' .###.#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($15)
		byte	$00	' ........
		byte	$00	' ........
		byte	$28	' ...#.#..
		byte	$10	' ....#...
		byte	$2a	' .#.#.#..
		byte	$06	' .##.....
		byte	$02	' .#......
		byte	$00	' ........

				' chr($16)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$36	' .##.##..

				' chr($17)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$3e	' .#####..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..

				' chr($18)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$14	' ..#.#...
		byte	$22	' .#...#..
		byte	$3e	' .#####..

				' chr($19)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....

				' chr($1a)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$02	' .#......
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$08	' ...#....

				' chr($1b)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($1c)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$2e	' .###.#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..

				' chr($1d)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2e	' .###.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$3e	' .#####..

				' chr($1e)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3a	' .#.###..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$3e	' .#####..

				' chr($1f)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$3a	' .#.###..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..

				' chr($20)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($21)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$08	' ...#....

				' chr($22)
		byte	$00	' ........
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($23)
		byte	$00	' ........
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$3e	' .#####..
		byte	$14	' ..#.#...
		byte	$3e	' .#####..
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...

				' chr($24)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$3c	' ..####..
		byte	$0a	' .#.#....
		byte	$1c	' ..###...
		byte	$28	' ...#.#..
		byte	$1e	' .####...
		byte	$08	' ...#....

				' chr($25)
		byte	$00	' ........
		byte	$06	' .##.....
		byte	$26	' .##..#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$32	' .#..##..
		byte	$30	' ....##..

				' chr($26)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$0a	' .#.#....
		byte	$0a	' .#.#....
		byte	$04	' ..#.....
		byte	$2a	' .#.#.#..
		byte	$12	' .#..#...
		byte	$2c	' ..##.#..

				' chr($27)
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($28)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$04	' ..#.....
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...

				' chr($29)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$10	' ....#...
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....

				' chr($2a)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$3e	' .#####..
		byte	$1c	' ..###...
		byte	$2a	' .#.#.#..
		byte	$08	' ...#....

				' chr($2b)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$3e	' .#####..
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........

				' chr($2c)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$04	' ..#.....
		byte	$02	' .#......

				' chr($2d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($2e)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....

				' chr($2f)
		byte	$00	' ........
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$00	' ........

				' chr($30)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$32	' .#..##..
		byte	$2a	' .#.#.#..
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($31)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$0c	' ..##....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...

				' chr($32)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$20	' .....#..
		byte	$1c	' ..###...
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$3e	' .#####..

				' chr($33)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$20	' .....#..
		byte	$18	' ...##...
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($34)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$18	' ...##...
		byte	$14	' ..#.#...
		byte	$12	' .#..#...
		byte	$3e	' .#####..
		byte	$10	' ....#...
		byte	$10	' ....#...

				' chr($35)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$1e	' .####...
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($36)
		byte	$00	' ........
		byte	$18	' ...##...
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$1e	' .####...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($37)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$02	' .#......

				' chr($38)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($39)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3c	' ..####..
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$0c	' ..##....

				' chr($3a)
		byte	$00	' ........
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$00	' ........

				' chr($3b)
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$0c	' ..##....
		byte	$04	' ..#.....
		byte	$02	' .#......

				' chr($3c)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...

				' chr($3d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$00	' ........
		byte	$00	' ........

				' chr($3e)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....

				' chr($3f)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$08	' ...#....

				' chr($40)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$20	' .....#..
		byte	$2c	' ..##.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...

				' chr($41)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$14	' ..#.#...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..

				' chr($42)
		byte	$00	' ........
		byte	$1e	' .####...
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$1c	' ..###...
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$1e	' .####...

				' chr($43)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($44)
		byte	$00	' ........
		byte	$1e	' .####...
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$24	' ..#..#..
		byte	$1e	' .####...

				' chr($45)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$0e	' .###....
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$3e	' .#####..

				' chr($46)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$0e	' .###....
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......

				' chr($47)
		byte	$00	' ........
		byte	$3c	' ..####..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$32	' .#..##..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3c	' ..####..

				' chr($48)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..

				' chr($49)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...

				' chr($4a)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($4b)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$12	' .#..#...
		byte	$0a	' .#.#....
		byte	$06	' .##.....
		byte	$0a	' .#.#....
		byte	$12	' .#..#...
		byte	$22	' .#...#..

				' chr($4c)
		byte	$00	' ........
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$3e	' .#####..

				' chr($4d)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$36	' .##.##..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..

				' chr($4e)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$26	' .##..#..
		byte	$2a	' .#.#.#..
		byte	$32	' .#..##..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..

				' chr($4f)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($50)
		byte	$00	' ........
		byte	$1e	' .####...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1e	' .####...
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......

				' chr($51)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2a	' .#.#.#..
		byte	$12	' .#..#...
		byte	$2c	' ..##.#..

				' chr($52)
		byte	$00	' ........
		byte	$1e	' .####...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1e	' .####...
		byte	$0a	' .#.#....
		byte	$12	' .#..#...
		byte	$22	' .#...#..

				' chr($53)
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$02	' .#......
		byte	$1c	' ..###...
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($54)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....

				' chr($55)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($56)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$08	' ...#....

				' chr($57)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2a	' .#.#.#..
		byte	$36	' .##.##..
		byte	$22	' .#...#..

				' chr($58)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$14	' ..#.#...
		byte	$22	' .#...#..
		byte	$22	' .#...#..

				' chr($59)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....

				' chr($5a)
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$20	' .....#..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$02	' .#......
		byte	$3e	' .#####..

				' chr($5b)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$2a	' .#.#.#..
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....

				' chr($5c)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$2a	' .#.#.#..
		byte	$1c	' ..###...
		byte	$08	' ...#....

				' chr($5d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$3e	' .#####..
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$00	' ........

				' chr($5e)
		byte	$00	' ........
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$3e	' .#####..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$00	' ........

				' chr($5f)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..

				' chr($60)
		byte	$00	' ........
		byte	$18	' ...##...
		byte	$18	' ...##...
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($61)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$20	' .....#..
		byte	$3c	' ..####..
		byte	$22	' .#...#..
		byte	$3c	' ..####..

				' chr($62)
		byte	$00	' ........
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$26	' .##..#..
		byte	$1a	' .#.##...

				' chr($63)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$02	' .#......
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($64)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$2c	' ..##.#..
		byte	$32	' .#..##..
		byte	$22	' .#...#..
		byte	$32	' .#..##..
		byte	$2c	' ..##.#..

				' chr($65)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$3e	' .#####..
		byte	$02	' .#......
		byte	$1c	' ..###...

				' chr($66)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$28	' ...#.#..
		byte	$08	' ...#....
		byte	$1c	' ..###...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....

				' chr($67)
		byte	$00	' ........
		byte	$2c	' ..##.#..
		byte	$32	' .#..##..
		byte	$32	' .#..##..
		byte	$2c	' ..##.#..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($68)
		byte	$00	' ........
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..

				' chr($69)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...

				' chr($6a)
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$00	' ........
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($6b)
		byte	$00	' ........
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$12	' .#..#...
		byte	$0a	' .#.#....
		byte	$06	' .##.....
		byte	$0a	' .#.#....
		byte	$12	' .#..#...

				' chr($6c)
		byte	$00	' ........
		byte	$0c	' ..##....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$1c	' ..###...

				' chr($6d)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$16	' .##.#...
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..

				' chr($6e)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..

				' chr($6f)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1c	' ..###...
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($70)
		byte	$00	' ........
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$22	' .#...#..
		byte	$26	' .##..#..
		byte	$1a	' .#.##...
		byte	$02	' .#......
		byte	$02	' .#......

				' chr($71)
		byte	$00	' ........
		byte	$2c	' ..##.#..
		byte	$32	' .#..##..
		byte	$22	' .#...#..
		byte	$32	' .#..##..
		byte	$2c	' ..##.#..
		byte	$20	' .....#..
		byte	$20	' .....#..

				' chr($72)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$1a	' .#.##...
		byte	$26	' .##..#..
		byte	$02	' .#......
		byte	$02	' .#......
		byte	$02	' .#......

				' chr($73)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3c	' ..####..
		byte	$02	' .#......
		byte	$1c	' ..###...
		byte	$20	' .....#..
		byte	$1e	' .####...

				' chr($74)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$3e	' .#####..
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$28	' ...#.#..
		byte	$10	' ....#...

				' chr($75)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$32	' .#..##..
		byte	$2c	' ..##.#..

				' chr($76)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....

				' chr($77)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$2a	' .#.#.#..
		byte	$2a	' .#.#.#..
		byte	$14	' ..#.#...

				' chr($78)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$14	' ..#.#...
		byte	$08	' ...#....
		byte	$14	' ..#.#...
		byte	$22	' .#...#..

				' chr($79)
		byte	$00	' ........
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
		byte	$3c	' ..####..
		byte	$20	' .....#..
		byte	$22	' .#...#..
		byte	$1c	' ..###...

				' chr($7a)
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$3e	' .#####..

				' chr($7b)
		byte	$00	' ........
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$10	' ....#...

				' chr($7c)
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$00	' ........
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$08	' ...#....

				' chr($7d)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$10	' ....#...
		byte	$08	' ...#....
		byte	$08	' ...#....
		byte	$04	' ..#.....

				' chr($7e)
		byte	$00	' ........
		byte	$04	' ..#.....
		byte	$2a	' .#.#.#..
		byte	$10	' ....#...
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........
		byte	$00	' ........

				' chr($7f)
		byte	$00	' ........
		byte	$14	' ..#.#...
		byte	$2a	' .#.#.#..
		byte	$14	' ..#.#...
		byte	$2a	' .#.#.#..
		byte	$14	' ..#.#...
		byte	$2a	' .#.#.#..
		byte	$14	' ..#.#...

chr0
		byte	$00	' ........
		byte	$3e	' .#####..
		byte	$22	' .#...#..
		byte	$22	' .#...#..
gfx
		byte	$00	' ........
		byte	$38	' ..###...
		byte	$07	' .....###
		byte	$3f	' ..######

startup
		mov	entry, chr0

		mov	t1, PAR				' pointer to 4 longs (sync, screen, bitmaps, tvPin)
		rdlong	sync_ptr, t1			' get address of sync long
		add	t1, #4
		rdlong	video_ptr, t1			' get address of video buffer
		add	t1, #4
		rdlong	bitmap_ptr, t1			' get address of bitmap buffer
		add	bitmap_end, bitmap_ptr

render_frame
:wait		rdlong	t1, sync_ptr		WZ
		cmp	t1, scanline
	if_nz	jmp	#:wait
		mov	scanline, #1

		mov	charptr0, video_ptr
		mov	bmapptr, bitmap_ptr
		mov	scanpart, #0
		mov	scanshift, #0
		mov	rows, #16*12
render_row
		mov	charptr, charptr0
		mov	cols, #64
render_col
		rdbyte	ch, charptr			' get character code
		add	charptr, #1
		cmp	ch, #$80		WZ, WC	' block graphics?
	if_ae	jmp	#graphics

		shl	ch, #1				' char * 2 = long address in chargen
		add	ch, scanpart			' index 1st or 2nd long per character
		movs	:chrgen, ch
		nop
:chrgen		mov	bits, 0-0			' get bits
		shr	bits, scanshift			' rotate 0, 8, 16 or 24 times
		cmp	scanpart, #2		WZ	' scan rows 8..11 ?
	if_z	mov	bits, #0			' emit empty lines

render_bits
		shr	out1, #6			' rotate 6 bits into two outputs
		mov	t1, out0			' get first output
		shl	t1, #32-6			' shift 5..0 to 31..16
		or	out1, t1			' put in second output
		shr	out0, #6			' open up bits 31..26
		shl	bits, #32-6			' shift 5..0 to 31..16
		or	out0, bits			' paste 6 new bits in 1st output

		add	outcnt, #6			' 6 more bits in the 64 bit output shifter
		cmp	outcnt, #32		WZ, WC	' do we have a complete long?
	if_ae	wrlong	out0, bmapptr			' yes, write it to the bitmap
	if_ae	add	bmapptr, #4			' next destination address
	if_ae	mov	out0, out1			' copy overlapping bits to out0
	if_ae	sub	outcnt, #32			' subtract 32 bits

		djnz	cols, #render_col

		add	scanshift, #8			' shift count += 8
		and	scanshift, #24		WZ	' next long of the chargen?
	if_z	add	scanpart, #1			' use 2nd long from chargen next time, or blank bits 3rd time
	if_z	cmp	scanpart, #3		WZ	' next character row?
	if_z	mov	scanpart, #0			' reset scanpart
	if_z	add	charptr0, #64			' next row of characters after video_ptr

		cmp	bmapptr, bitmap_end	WZ, WC	' ... re-start the bitmap pointer?
	if_ae	mov	bmapptr, bitmap_ptr

' wait for video cog to be finished with the other bitmap
:wait		rdlong	t1, sync_ptr
		cmp	t1, scanline		WZ, WC
	if_b	jmp	#:wait
		add	scanline, #1

		djnz	rows, #render_row		' do the next scanline row

		jmp	#render_frame			' next frame

graphics
		shr	ch, scanpart			' shift the active bits
		shr	ch, scanpart			' intro ch 1..0
		and	ch, #3				' mask 1..0
		shl	ch, #3				' * 8 gives 0, 8, 16 or 24
		mov	bits, gfx			' fetch the pixel bit mask
		shr	bits, ch
		jmp	#render_bits			' continue just as with chargen data

'******************************************************************************

video_ptr	long	0-0				' pointer to 64x16 bytes video RAM
bitmap_ptr	long	0-0				' pointer to 64x6x2 bits bitmap buffer
bitmap_end	long	64*6*2/8			' number of bytes in the bitmap buffers
sync_ptr	long	0-0				' pointer to the render / video synchronization

scanline	long	0
scanshift	long	0				' scanshift rotation value for the chargen longs
scanpart	long	0				' scan
charptr0	long	0				' per character row pointer into video_ptr
charptr		long	0				' per scanline pointer into video_ptr
bmapptr		long	0				' bitmap buffer pointer per column
ch		long    0
bits		long    0
out0		long	0				' first pixel accumulator
out1		long	0				' second pixel accumulator
outcnt		long	0				' number of bits in both accumulators
rows		long    0				' loop counter - number of rows
cols		long    0				' loop counter - number of columns
t1		long    0
null		long	0


		fit	$1f0
